SystemOrganization addCategory: #PharoPeople!

Object subclass: #PharoPeopleObject
	instanceVariableNames: 'id email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoPeople'!

!PharoPeopleObject commentStamp: '<historical>' prior: 0!
A PharoPeopleObject is the root of the PharoPeople objects that we can manipulate in the collected lists.!

!PharoPeopleObject methodsFor: 'default' stamp: 'StephaneDucasse 10/23/2013 11:24'!
defaultEmail
	^ 'pharo-dev@lists.pharo.org'! !

!PharoPeopleObject methodsFor: 'accessing' stamp: 'StephaneDucasse 10/23/2013 11:24'!
email
	^ email ifNil: [ self defaultEmail ]! !

!PharoPeopleObject methodsFor: 'accessing' stamp: 'StephaneDucasse 10/23/2013 11:24'!
email: anObject
	email := anObject! !

!PharoPeopleObject methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 11/19/2014 16:22'!
id
	^ id! !

!PharoPeopleObject methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 11/19/2014 16:21'!
id: anObject
	id := anObject! !

PharoPeopleObject subclass: #PharoPerson
	instanceVariableNames: 'name website'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoPeople'!

!PharoPerson commentStamp: '<historical>' prior: 0!
PharoPerson describes an individual's online attributes.

Instance Variables
	email <String> john@foo.com
	name <String> John Doe
	website <String> http:://people.foo.com/john
	id <String> johndoe

!

PharoPerson subclass: #PharoConsultant
	instanceVariableNames: 'location languages industryExperienceSince pharoExperienceSince areasOfExpertise smalltalkExperienceSince'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoPeople'!

!PharoConsultant commentStamp: '<historical>' prior: 0!
PharoConsultant is a PharoPerson that offers consultancy services related to Pharo technology.

Instance Variables
	areasOfExpertise <String> web apps, GUI & compiler
	languages <String> French (native), English
	location <String> Paris, France
	pharoExperienceSince <Integer> 2011
	smalltalkExperienceSInce <Integer> 2005
	industryExperienceSince <Integer> 2000

!

!PharoConsultant class methodsFor: 'examples' stamp: 'SvenVanCaekenberghe 7/11/2013 21:58'!
demo
	^ #(svc nh jvds sd mp) collect: [ :each | self perform: each ]! !

!PharoConsultant class methodsFor: 'examples' stamp: 'SvenVanCaekenberghe 7/16/2013 11:32'!
jvds
	^ self new
		name: 'Jan van de Sandt';
		location: 'Utrecht, The Netherlands';
		email: 'jan@mcast.fm';
		website: 'http://doit.st';
		languages: 'Dutch (native), English';
		industryExperienceSince: 1994;
		smalltalkExperienceSince: 1993;
		pharoExperienceSince: 2009;
		areasOfExpertise: 'Business applications, enterprise integration and web applications';
		yourself! !

!PharoConsultant class methodsFor: 'examples' stamp: 'SvenVanCaekenberghe 7/16/2013 11:32'!
mp
	^ self new
		name: 'Mariano Martinez Peck';
		location: 'Buenos Aires, Argentina';
		email: 'marianopeck@gmail.com';
		website: 'http://marianopeck.wordpress.com/';
		languages: 'Spanish (native), English (fluent, Cambridge FCE), French (basic)';
		industryExperienceSince: 2006;
		smalltalkExperienceSince: 2008;
		pharoExperienceSince: 2009;
		areasOfExpertise: 'Libraries and frameworks, web applications and backends, databases and serialization, protocols, virtual machine, system administration';
		yourself! !

!PharoConsultant class methodsFor: 'examples' stamp: 'SvenVanCaekenberghe 7/16/2013 11:32'!
nh
	^ self new
		name: 'Norbert Hartl';
		location: 'Cologne, Germany';
		email: 'norbert@2denker.de';
		website: 'http://2denker.de';
		languages: 'German (native), English';
		industryExperienceSince: 1994;
		smalltalkExperienceSince: 2002;
		pharoExperienceSince: 2008;
		areasOfExpertise: 'Web applications and backends, mobile applications, protocols, embedded software, distributed systems, broadcasting, telecommunications';
		yourself! !

!PharoConsultant class methodsFor: 'examples' stamp: 'SvenVanCaekenberghe 7/16/2013 11:32'!
sd
	^ self new
		name: 'Sean DeNigris';
		location: 'New York, USA';
		email: 'sean@clipperadams.com';
		website: 'http://seandenigris.com';
		languages: 'English (native)';
		industryExperienceSince: 1996;
		smalltalkExperienceSince: 2010;
		pharoExperienceSince: 2010;
		areasOfExpertise: 'Small business applications; web applications & servers; DDD & customer communication; TDD/BDD';
		yourself! !

!PharoConsultant class methodsFor: 'examples' stamp: 'SvenVanCaekenberghe 7/16/2013 11:32'!
svc
	^ self new
		name: 'Sven Van Caekenberghe';
		location: 'Hasselt, Belgium';
		email: 'sven@stfx.eu';
		website: 'http://stfx.eu';
		languages: 'Dutch (native), English, French, German';
		industryExperienceSince: 1990;
		smalltalkExperienceSince: 1993;
		pharoExperienceSince: 2010;
		areasOfExpertise: 'Web Services & Applications, Servers, Networking, Protocols';
		yourself! !

!PharoConsultant methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/11/2013 15:08'!
areasOfExpertise
	^ areasOfExpertise! !

!PharoConsultant methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/11/2013 15:08'!
areasOfExpertise: anObject
	areasOfExpertise := anObject! !

!PharoConsultant methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 8/12/2013 15:04'!
fields
	^ super fields, #( location industryExperienceSince smalltalkExperienceSince pharoExperienceSince areasOfExpertise languages )! !

!PharoConsultant methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/11/2013 15:08'!
industryExperienceSince
	^ industryExperienceSince! !

!PharoConsultant methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/11/2013 15:08'!
industryExperienceSince: anObject
	industryExperienceSince := anObject! !

!PharoConsultant methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/11/2013 15:08'!
languages
	^ languages! !

!PharoConsultant methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/11/2013 15:08'!
languages: anObject
	languages := anObject! !

!PharoConsultant methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/11/2013 15:08'!
location
	^ location! !

!PharoConsultant methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/11/2013 15:08'!
location: anObject
	location := anObject! !

!PharoConsultant methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/11/2013 15:08'!
pharoExperienceSince
	^ pharoExperienceSince! !

!PharoConsultant methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/11/2013 15:08'!
pharoExperienceSince: anObject
	pharoExperienceSince := anObject! !

!PharoConsultant methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/16/2013 11:32'!
smalltalkExperienceSince
	^ smalltalkExperienceSince! !

!PharoConsultant methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/16/2013 11:32'!
smalltalkExperienceSince: anObject
	smalltalkExperienceSince := anObject! !

PharoPerson subclass: #PharoContributor
	instanceVariableNames: 'description image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoPeople'!

!PharoContributor commentStamp: '<historical>' prior: 0!
PharoContributor is a PharoPerson that has contributed to the Pharo Project.

Instance Variables
	description <String> Loves object systems, enjoys hacking.
	image <String> http://me.com/picture.jpeg

!

!PharoContributor class methodsFor: 'examples' stamp: 'SvenVanCaekenberghe 7/17/2013 15:26'!
demo
	^ #(md sd ll tg) collect: [ :each | self perform: each ]! !

!PharoContributor class methodsFor: 'examples' stamp: 'SvenVanCaekenberghe 7/17/2013 15:26'!
ll
	^ self new
		name: 'Laurent Laffont';
		email: 'laurent.laffont@gmail.com';
		website: 'http://magaloma.blogspot.com/';
		description: 'Use Pharo for testing web application, and teaching software development. Contribute to Pharocasts, ProfStef, Autotest.';
		image: 'http://b.vimeocdn.com/ps/765/765789_300.jpg';
		yourself! !

!PharoContributor class methodsFor: 'examples' stamp: 'SvenVanCaekenberghe 7/17/2013 15:20'!
md
	^ self new
		name: 'Marcus Denker';
		email: 'marcus.denker@inria.fr';
		website: 'http://marcusdenker.de/';
		description: 'Permanent researcher at INRIA Lille in RMoD Team. Pharo board member.';
		image: 'http://marcusdenker.de/marcus.jpg';
		yourself! !

!PharoContributor class methodsFor: 'examples' stamp: 'SvenVanCaekenberghe 7/17/2013 10:30'!
sd
	^ self new
		name: 'Stéphane Ducasse';
		id: 'stephaneducasse';
		email: 'stephane.ducasse@inria.fr';
		website: 'http://stephane.ducasse.free.fr/';
		description: 'Research director at INRIA Lille leading the RMoD Team. Pharo board member and president of ESUG.';
		image: 'http://stephane.ducasse.free.fr/StefFingerOnNose128.jpg';
		yourself! !

!PharoContributor class methodsFor: 'examples' stamp: 'SvenVanCaekenberghe 7/17/2013 15:20'!
tg
	^ self new
		name: 'Tudor "Doru" Girba';
		id: 'tudorgirba';
		email: 'tudor@tudorgirba.com';
		website: 'http://www.tudorgirba.com/';
		description: 'Consultant through netstyle.ch, concerned with communicating and modeling information in general. Leads the work on the Moose analysis platform since 2003.';
		image: 'http://www.tudorgirba.com/?_s=IMmLz0gQNuyJ-_x_';
		yourself! !

!PharoContributor methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/31/2013 12:56'!
defaultImage
	^ 'http://upload.wikimedia.org/wikipedia/commons/thumb/8/85/Smiley.svg/500px-Smiley.svg.png'! !

!PharoContributor methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/11/2013 15:08'!
description
	^ description! !

!PharoContributor methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/11/2013 15:08'!
description: anObject
	description := anObject! !

!PharoContributor methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 8/12/2013 15:04'!
fields
	^ super fields, #( description image )! !

!PharoContributor methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 8/2/2013 17:22'!
findImageEntity
	image ifNotNil: [ ^ self imageEntity ].
	^ [ self gravatarEntity ]
		on: ZnHttpUnsuccessful 
		do: [ self imageEntity "this will use #defaultImage now" ]! !

!PharoContributor methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 8/2/2013 17:21'!
form
	^ self formForImageEntity: self findImageEntity! !

!PharoContributor methodsFor: 'private' stamp: 'SvenVanCaekenberghe 7/17/2013 13:21'!
formForImageEntity: imageEntity
	"Parse the actual bytes of imageEntity and return a Form."
	
	| imageType parserClassName parserClass parser |
	imageType := imageEntity contentType sub.
	parserClassName := imageType asUppercase, #ReadWriter.
	parserClass := Smalltalk globals at: parserClassName asSymbol.
	parser := parserClass on: imageEntity readStream.
	^ parser nextImage! !

!PharoContributor methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 8/2/2013 17:17'!
gravatarEntity
	^ ZnClient new 
		enforceHttpSuccess: true;
		beOneShot; 
		url: 'http://www.gravatar.com/avatar';
		addPathSegment: (ZnDigestAuthenticator md5Hash: self email);
		queryAt: #s put: '128';
		queryAt: #d put: '404';
		get;
		entity! !

!PharoContributor methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/31/2013 12:56'!
image
	^ image ifNil: [ self defaultImage ]! !

!PharoContributor methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/17/2013 10:28'!
image: anObject
	image := anObject! !

!PharoContributor methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/17/2013 13:33'!
imageEntity
	^ ZnClient new 
		enforceHttpSuccess: true;
		beOneShot; 
		get: self image;
		entity! !

!PharoContributor methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/17/2013 13:26'!
processedForm
	^ self form scaledIntoFormOfSize: 128! !

!PharoContributor methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/17/2013 15:08'!
processedImageUrl
	^ 'pharo-contributor-{1}.png' format: { self id }! !

!PharoContributor methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/17/2013 13:28'!
processedPngEntity
	^ ZnEntity
		with: (ByteArray streamContents: [ :out |
			(PNGReadWriter on: out) nextPutImage: self processedForm ])
		type: ZnMimeType imagePng! !

!PharoPerson methodsFor: 'converting' stamp: 'SvenVanCaekenberghe 8/12/2013 15:06'!
asSmalltalkExpression
	^ String streamContents: [ :out |
		out << self class name; space; << 'new'; cr.
		self fields do: [ :each |
			(self instVarNamed: each)
				ifNotNil: [ :value |
					out tab; << each asMutator; space; print: value; nextPut: $; ; cr ] ].
		out tab; << 'yourself'; cr ]! !

!PharoPerson methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/31/2013 13:30'!
defaultWebsite
	^ ZnUrl new
		scheme: #http;
		host: 'www.google.com';
		addPathSegment: 'search';
		queryAt: 'q' put: self name;
		yourself! !

!PharoPerson methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 8/12/2013 15:02'!
fields
	^ #( name id email website )! !

!PharoPerson methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 11/19/2014 16:21'!
id
	^ id ifNil: [ id := (name select: [ :each | each isLetter ]) asLowercase ]! !

!PharoPerson methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/11/2013 15:08'!
name
	^ name! !

!PharoPerson methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/11/2013 15:08'!
name: anObject
	name := anObject! !

!PharoPerson methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 7/11/2013 21:51'!
printOn: stream
	super printOn: stream.
	stream
		nextPut: $(;
		<< self id;
		nextPut: $)! !

!PharoPerson methodsFor: 'converting' stamp: 'SvenVanCaekenberghe 7/18/2013 10:58'!
stonString
	^ STON toStringPretty: self! !

!PharoPerson methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/31/2013 13:00'!
website
	^ website ifNil: [ self defaultWebsite ]! !

!PharoPerson methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/11/2013 15:08'!
website: anObject
	website := anObject! !

PharoPeopleObject subclass: #PharoTopic
	instanceVariableNames: 'context date goal keywords supervisors title level candidate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoPeople'!

!PharoTopic commentStamp: '<historical>' prior: 0!
PharoTopic describes a master or bachelor topic.!

!PharoTopic class methodsFor: 'instance creation' stamp: 'StephaneDucasse 10/22/2013 22:32'!
contact: contact context: context date: date goal: goal keywords: keywords supervisors: supervisors title: title

	^ self new
		contact: contact;
		context: context;
		date: date;
		goal: goal;
		keywords: keywords;
		supervisors: supervisors;
		title: title;
		yourself! !

!PharoTopic class methodsFor: 'instance creation' stamp: 'StephaneDucasse 10/22/2013 22:32'!
sample
	"self sample"
	^ PharoTopic new
		title: 'Better Message Browser';
		contact: 'stephane.ducasse@inria.fr';
		supervisors: 'S. Ducasse / B. van Ryseghem';
		keywords: 'tools ui spec';
		context: 'The browser showing results of senders and implementors won''t help you navigate in the call chain. Often we want to perform a sender on a message and would like to see if there are senders of the senders. This is typically interesting when doing cleaning.';
		goal: 'The goal of the project is to define a tool to support message browsing.';
		yourself
	! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 11/8/2013 02:56'!
candidate
	
	^ candidate ifNil: [ candidate := 'Topic still free' ].! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 11/8/2013 02:51'!
candidate: anObject
	
	candidate := anObject! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 10/23/2013 14:37'!
contact
	
	^ email! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 10/23/2013 13:33'!
contact: anObject
	
	email := anObject! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 10/23/2013 14:37'!
context
	
	^ context! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 10/22/2013 22:32'!
context: anObject
	
	context := anObject! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 10/23/2013 14:37'!
date
	
	^ date! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 10/22/2013 22:32'!
date: anObject
	
	date := anObject! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 10/23/2013 14:37'!
goal
	
	^ goal! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 10/22/2013 22:32'!
goal: anObject
	
	goal := anObject! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 10/23/2013 11:11'!
id
	^ id ifNil: [ id := (title select: [ :each | each isLetter ]) asLowercase ]! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 10/23/2013 14:37'!
keywords
	
	^ keywords! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 10/22/2013 22:32'!
keywords: anObject
	
	keywords := anObject! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 11/3/2013 17:24'!
level

	^ level ifNil: [ 'Currently undefined, we are working on it.' ]! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 11/3/2013 17:24'!
level: aString
	
	level := aString! !

!PharoTopic methodsFor: 'printing' stamp: 'StephaneDucasse 11/8/2013 02:52'!
printOn: aStream

	aStream << self class name; << ' new '; cr.
	aStream tab << 'title: '.
	aStream tab << title printString ; << ';' ; cr.
	aStream tab << 'keywords: '.
	aStream tab << keywords printString << ';' ; cr.
	aStream tab << 'contact: '.
	aStream tab << email printString << ';' ; cr.
	aStream tab << 'supervisors: '.
	aStream tab << supervisors printString << ';' ; cr.
	aStream tab << 'context: '.
	aStream tab << context printString << ';' ; cr.
	aStream tab << 'goal: '.
	aStream tab << goal printString << ';' ; cr.
	aStream tab << 'level: '.
	aStream tab << self level printString << ';' ; cr.
	aStream tab << 'candidate: '.
	aStream tab << self candidate printString << ';' ; cr.
	aStream tab << 'yourself'
	! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 10/23/2013 14:37'!
supervisors
	
	^ supervisors! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 10/22/2013 22:32'!
supervisors: anObject
	
	supervisors := anObject! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 10/23/2013 14:37'!
title
	
	^ title! !

!PharoTopic methodsFor: 'accessing' stamp: 'StephaneDucasse 10/22/2013 22:32'!
title: anObject
	
	title := anObject! !

Object subclass: #PharoPeoplePageTool
	instanceVariableNames: 'stream data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoPeople'!

!PharoPeoplePageTool commentStamp: '<historical>' prior: 0!
PharoPeoplePageTool generates HTML based on data.!

PharoPeoplePageTool subclass: #PharoConsultantPageTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoPeople'!

!PharoConsultantPageTool commentStamp: '<historical>' prior: 0!
PharoConsultantPageTool generates an HTML page listing all Pharo Consultants.

PharoConsultantPageTool new
	loadFromFile;
	yourself.
	
PharoConsultantPageTool new
	loadFromFile;
	generatePageFile.!

!PharoConsultantPageTool methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/17/2013 13:36'!
defaultFile
	^ 'pharo-consultants'! !

!PharoConsultantPageTool methodsFor: 'html generation' stamp: 'SvenVanCaekenberghe 7/29/2013 11:55'!
generateEntryElementsFor: consultant
	self tag: #tr with: [ 
		self tag: #td with: [ stream << 'Name' ].
		self tag: #td with: [ 
			self tag: #span attributes: { #class -> 'cn' } asDictionary with: [ stream << consultant name ] ] ].
	self tag: #tr with: [ 
		self tag: #td with: [ stream << 'Location' ].
		self tag: #td with: [ stream << consultant location ] ].
	self tag: #tr with: [ 
		self tag: #td with: [ stream << 'Email' ].
		self tag: #td with: [ self generateEmailFor: consultant ] ].
	self tag: #tr with: [ 
		self tag: #td with: [ stream << 'Website' ].
		self tag: #td with: [ self generateWebsiteLinkFor: consultant ] ].
	self tag: #tr with: [ 
		self tag: #td with: [ stream << 'Industry Experience' ].
		self tag: #td with: [ stream << 'since '; print: consultant industryExperienceSince ] ].
	self tag: #tr with: [ 
		self tag: #td with: [ stream << 'Smalltalk Experience' ].
		self tag: #td with: [ stream << 'since '; print: consultant smalltalkExperienceSince ] ].
	self tag: #tr with: [ 
		self tag: #td with: [ stream << 'Pharo Experience' ].
		self tag: #td  with: [ stream << 'since '; print: consultant pharoExperienceSince ] ].
	self tag: #tr with: [ 
		self tag: #td with: [ stream << 'Languages' ].
		self tag: #td with: [ stream << consultant languages ] ].
	self tag: #tr with: [ 
		self tag: #td with: [ stream << 'Areas Of Expertise' ].
		self tag: #td with: [ stream << consultant areasOfExpertise ] ]! !

!PharoConsultantPageTool methodsFor: 'html generation' stamp: 'SvenVanCaekenberghe 7/16/2013 13:22'!
generateEntryFor: consultant
	self tag: #a attributes: { #name -> consultant id } asDictionary with: [   
		self tag: #p with: [ 
			self tag: #table with: [ 
				stream << self tableColGroup.
				self generateEntryElementsFor: consultant ] ] ]! !

!PharoConsultantPageTool methodsFor: 'constants' stamp: 'SvenVanCaekenberghe 11/19/2014 14:51'!
preamble
	^ '<p>Pharo consultants can help you to successfully realise your application or project based on Pharo technology. These professionals from all over the world have experience in building great software, in flexibly using object technology and specifically in working with Pharo and all the tools in its ecosystem.</p>
<p>These individuals are involved in the <a href="http://www.pharo.org">Pharo open source project</a> and are supporting Pharo through the <a href="http://association.pharo.org">Association</a> or <a href="http://consortium.pharo.org">Consortium</a>. Most of them have contributed to the Pharo code base or to open source frameworks and libraries running on top of Pharo.</p>
<p>Feel free to contact them to for more information and to negotiate terms, conditions and availability.</p>
<a href="http://www.pharo.org"><img src="http://pharo.org/web/files/pharo.png"/></a>
<p class="footer">( In random order )</p>'! !

!PharoConsultantPageTool methodsFor: 'constants' stamp: 'SvenVanCaekenberghe 7/16/2013 13:18'!
tableColGroup
	^ '<colgroup><col style="text-align:left;width:25%;"/><col style="text-align:left;"/></colgroup>'! !

!PharoConsultantPageTool methodsFor: 'constants' stamp: 'SvenVanCaekenberghe 7/12/2013 16:22'!
title
	^ 'Pharo Consultants'! !

PharoPeoplePageTool subclass: #PharoContributorsPageTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoPeople'!

!PharoContributorsPageTool commentStamp: '<historical>' prior: 0!
PharoTopicsPageTool generates an HTML page listing all topics for master and bachelor students.

PharoContributorsPageTool new
	loadFromFile;
	yourself.
	
PharoContributorsPageTool new
	loadFromFile;
	generatePageFile.!

!PharoContributorsPageTool methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/17/2013 14:20'!
defaultFile
	^ 'pharo-contributors'! !

!PharoContributorsPageTool methodsFor: 'html generation' stamp: 'SvenVanCaekenberghe 7/17/2013 15:11'!
ensureImageFor: contributor
	| file |
	file := contributor processedImageUrl asFileReference.
	file exists
		ifTrue: [ ^ self ].
	file writeStreamDo: [ :out |
		out binary.
		out nextPutAll: contributor processedPngEntity bytes ]
! !

!PharoContributorsPageTool methodsFor: 'html generation' stamp: 'SvenVanCaekenberghe 7/17/2013 15:27'!
generateEntryElementsFor: contributor
	self ensureImageFor: contributor.
	self tag: #tr with: [ 
		self tag: #td with: [ 
			self tag: #span attributes: { #class -> 'cn' } asDictionary with: [ stream << contributor name ] ].
		self tag: #td attributes: { #rowspan-> 4 } asDictionary with: [ 
			self tag: #img attributes: { #src -> contributor processedImageUrl } asDictionary with: [ ] ] ].
	self tag: #tr with: [ 
		self tag: #td with: [ self generateWebsiteLinkFor: contributor ] ].
	self tag: #tr with: [ 
		self tag: #td with: [ self generateEmailFor: contributor ] ].
	self tag: #tr with: [ 
		self tag: #td with: [ stream << contributor description ] ]! !

!PharoContributorsPageTool methodsFor: 'html generation' stamp: 'SvenVanCaekenberghe 7/17/2013 14:50'!
generateEntryFor: contributor
	self tag: #a attributes: { #name -> contributor id } asDictionary with: [   
		self tag: #p with: [ 
			self tag: #table with: [ 
				stream << self tableColGroup.
				self generateEntryElementsFor: contributor ] ] ]! !

!PharoContributorsPageTool methodsFor: 'constants' stamp: 'SvenVanCaekenberghe 8/12/2013 14:38'!
preamble
	^ '<p>These are some of the individuals from all over the world that have contributed to <a href="http://www.pharo.org">Pharo</a> over the years. They filed issues, fixed bugs and generally cleaned up code. They wrote documentation, answered questions on the mailing lists and wrote whole new subsystems.</p>
<p>Thank you !!</p>
<a href="http://www.pharo.org"><img src="http://www.pharo-project.org/images/pharo.png"/></a>
<p class="footer">( In random order )</p>'! !

!PharoContributorsPageTool methodsFor: 'constants' stamp: 'SvenVanCaekenberghe 7/17/2013 14:53'!
tableColGroup
	^ '<colgroup><col style="text-align:left;"/><col style="text-align:left;width:25%;"/></colgroup>'! !

!PharoContributorsPageTool methodsFor: 'constants' stamp: 'SvenVanCaekenberghe 7/17/2013 14:30'!
title
	^ 'Pharo Contributors'! !

!PharoPeoplePageTool methodsFor: 'adding removing' stamp: 'SvenVanCaekenberghe 7/31/2013 13:06'!
add: person
	data := self data copyWith: person! !

!PharoPeoplePageTool methodsFor: 'constants' stamp: 'SvenVanCaekenberghe 11/19/2014 14:49'!
css
	^ '
body{
  color:#74706f;
  font-size:18px;
  background:#f7f7f7;
  background-repeat:repeat-x;
  background-position:top center;
  background-image:url(http://files.pharo.org/media/pharoBackground.png);
  font-family:"Myriad Pro","Lucida Grande","Helvetica Neue",Arial,Helvetica,Geneva,sans-serif;
}
p { 
  line-height:1.4em;
  padding: 1em;
}
h1 {
  font-size:5em;
  color:#0d64af;
  color:rgba(13,100,175,0.9);
  padding:18px;
}
img {
  display: block;
  margin-left: auto;
  margin-right: auto;
}
table {
  border-collapse:collapse;
  border-spacing:0;
  font-size:100%;
  font:inherit;
  width:100%;
}
table td {
  border:1px solid #ccc;
  padding:6px 13px;
}
table tr {
  border-top:1px solid #ccc;
  background-color:#fff;
}
span.cn { 
  font-weight:bold;
  color:black;
}
p.footer { 
  font-size:0.75em;
  text-align:center;
  font-style:italic;
}
'! !

!PharoPeoplePageTool methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/31/2013 13:06'!
data
	^ data ifNil: [ Array new ]! !

!PharoPeoplePageTool methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 7/17/2013 13:41'!
data: anObject
	data := anObject! !

!PharoPeoplePageTool methodsFor: 'default' stamp: 'SvenVanCaekenberghe 7/17/2013 13:41'!
defaultDataFile
	^ self defaultFile, '.ston'! !

!PharoPeoplePageTool methodsFor: 'default' stamp: 'StephaneDucasse 10/23/2013 11:06'!
defaultFile
	"returns the name of the file used to load data as well as generate html"
	^ self subclassResponsibility! !

!PharoPeoplePageTool methodsFor: 'default' stamp: 'SvenVanCaekenberghe 7/17/2013 13:41'!
defaultHtmlFile
	^ self defaultFile, '.html'! !

!PharoPeoplePageTool methodsFor: 'html generation' stamp: 'SvenVanCaekenberghe 7/17/2013 15:43'!
generateBody
	^ self tag: #body with: [ 
		self tag: #h1 with: [ stream << self title ].
		stream << self preamble.
		data shuffled do: [ :each |
			self generateEntryFor: each.
			stream << String crlf ].
		stream << self postamble ]! !

!PharoPeoplePageTool methodsFor: 'html generation' stamp: 'SvenVanCaekenberghe 10/12/2013 21:46'!
generateEmailFor: person
	| percentEncoder url |
	percentEncoder := ZnPercentEncoder new safeSet: ''; yourself.
	url := 'mailto:{1}' format: { percentEncoder encode: person email }.
	self 
		tag: #a 
		attributes: { #href -> url } asDictionary 
		with: [ 
			person email do: [ :each | 
				self tag: #span with: [ stream nextPut: each ] ] ] ! !

!PharoPeoplePageTool methodsFor: 'html generation' stamp: 'SvenVanCaekenberghe 7/17/2013 13:43'!
generateEntryFor: consultant
	self subclassResponsibility! !

!PharoPeoplePageTool methodsFor: 'html generation' stamp: 'SvenVanCaekenberghe 7/17/2013 15:04'!
generateHeader
	self tag: #head with: [ 
		stream << '<meta charset="utf-8">'.
		self tag: #title with: [ stream << self title ].
		self tag: #style with: [ stream << self css ] ]! !

!PharoPeoplePageTool methodsFor: 'html generation' stamp: 'SvenVanCaekenberghe 7/17/2013 13:43'!
generatePage
	self
		tag: #html
		with: [ 
			self generateHeader.
			self generateBody ]! !

!PharoPeoplePageTool methodsFor: 'public' stamp: 'SvenVanCaekenberghe 7/17/2013 13:40'!
generatePageFile
	self generatePageFile: self defaultHtmlFile! !

!PharoPeoplePageTool methodsFor: 'public' stamp: 'SvenVanCaekenberghe 7/31/2013 13:14'!
generatePageFile: file
	file asFileReference ensureDelete.
	stream := file asFileReference writeStream.
	self generatePage.
	stream close.! !

!PharoPeoplePageTool methodsFor: 'html generation' stamp: 'SvenVanCaekenberghe 7/17/2013 14:25'!
generateWebsiteLinkFor: person
	| url |
	url := person website asZnUrl.
	self 
		tag: #a 
		attributes: { #href -> url asString } asDictionary 
		with: [ stream print: url ]! !

!PharoPeoplePageTool methodsFor: 'public' stamp: 'SvenVanCaekenberghe 7/17/2013 13:40'!
loadFromFile
	self loadFromFile: self defaultDataFile! !

!PharoPeoplePageTool methodsFor: 'public' stamp: 'SvenVanCaekenberghe 7/17/2013 13:40'!
loadFromFile: file
	file asFileReference readStreamDo: [ :in |
		data := STON fromStream: in ]! !

!PharoPeoplePageTool methodsFor: 'constants' stamp: 'SvenVanCaekenberghe 11/19/2014 14:57'!
postamble
	^ '<img src="http://pharo.org/web/files/pharo-logo-small.png"/><p class="footer">Page last generated on {1} by {2}</p>' format: { DateAndTime now. SystemVersion current }! !

!PharoPeoplePageTool methodsFor: 'constants' stamp: 'SvenVanCaekenberghe 7/17/2013 13:42'!
preamble
	^ self subclassResponsibility! !

!PharoPeoplePageTool methodsFor: 'adding removing' stamp: 'SvenVanCaekenberghe 7/31/2013 13:40'!
removePersonWithID: id
	data := self data reject: [ :each | each id = id ]! !

!PharoPeoplePageTool methodsFor: 'adding removing' stamp: 'SvenVanCaekenberghe 8/12/2013 22:00'!
replace: person
	data at: (self data findFirst: [ :each | each id = person id ]) put: person
	! !

!PharoPeoplePageTool methodsFor: 'public' stamp: 'SvenVanCaekenberghe 7/17/2013 13:40'!
saveToFile
	self saveToFile: self defaultDataFile! !

!PharoPeoplePageTool methodsFor: 'public' stamp: 'SvenVanCaekenberghe 7/31/2013 13:17'!
saveToFile: file
	file asFileReference ensureDelete.
	file asFileReference writeStreamDo: [ :out |
		(STON writer on: out)
			newLine: String crlf;
			prettyPrint: true;
			nextPut: data ]! !

!PharoPeoplePageTool methodsFor: 'html generation' stamp: 'SvenVanCaekenberghe 7/17/2013 13:42'!
tag: tag attributes: dictionary with: block
	stream nextPut: $<; nextPutAll: tag.
	dictionary keysAndValuesDo: [ :key :value | 
		stream space; << key; nextPut: $=; nextPut: $"; << value; nextPut: $" ]. 
	stream nextPut: $>.
	block value.
	stream nextPut: $<; nextPut: $/; nextPutAll: tag; nextPut: $>.! !

!PharoPeoplePageTool methodsFor: 'html generation' stamp: 'SvenVanCaekenberghe 7/17/2013 13:42'!
tag: tag with: block
	stream nextPut: $<; nextPutAll: tag; nextPut: $>.
	block value.
	stream nextPut: $<; nextPut: $/; nextPutAll: tag; nextPut: $>.! !

!PharoPeoplePageTool methodsFor: 'constants' stamp: 'SvenVanCaekenberghe 7/17/2013 13:42'!
title
	^ self subclassResponsibility! !

PharoPeoplePageTool subclass: #PharoTopicsPageTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoPeople'!

!PharoTopicsPageTool commentStamp: 'SvenVanCaekenberghe 2/22/2015 17:26' prior: 0!
A PharoTopicsPageTool generates a html for master and bachelor topics.

PharoTopicsPageTool
	new 
	dataFromUrl: 'https://raw.github.com/pharo-project/pharo-project-proposals/master/Topics.st';
	generatePageFile.

For debugging 
	
PharoTopicsPageTool
	new 
	dataFromFile: '/Users/sven/Develop/git/pharo-project-proposals/Topics.st';
	generatePageFile.
!

!PharoTopicsPageTool methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 2/22/2015 17:21'!
dataFromFile: filepath
	"Assuming filepath points to a file containing Smalltalk expressions separated by dots on a line on their own, 
	evaluate the objects found there and assign them to data"
	
	| separator fileContents in |
	separator := String lf, '.', String lf, String lf.
	fileContents := filepath asFileReference contents.
	data := Array streamContents: [ :out |
		in := fileContents readStream.
		[ | oneTopic |
			oneTopic := (in upToAll: separator) trimBoth.
			oneTopic isEmpty
				ifTrue: [ false ]
				ifFalse: [ 
					out nextPut: ([ Compiler new evaluate: oneTopic ] on: Error do: [ oneTopic inspect. self halt ]).
					true ] ] whileTrue ]! !

!PharoTopicsPageTool methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 2/22/2015 17:33'!
dataFromUrl: url
	"Assuming url points to a file containing Smalltalk expressions separated by dots on a line on their own, 
	evaluate the objects found there and assign them to data"
	
	| separator fileContents in |
	separator := String lf, '.', String lf, String lf.
	fileContents := ZnClient new get: url.
	data := Array streamContents: [ :out |
		in := fileContents readStream.
		[ | oneTopic |
			oneTopic := (in upToAll: separator) trimBoth.
			oneTopic isEmpty
				ifTrue: [ false ]
				ifFalse: [ 
					out nextPut: (Compiler new evaluate: oneTopic).
					true ] ] whileTrue ]! !

!PharoTopicsPageTool methodsFor: 'default' stamp: 'StephaneDucasse 10/23/2013 11:05'!
defaultFile
	^ 'pharo-topics'! !

!PharoTopicsPageTool methodsFor: 'html generation' stamp: 'StephaneDucasse 2/11/2015 17:13'!
generateEntryElementsFor: topic
	
	self tag: #tr with: [ 
		self tag: #td with: [ stream << 'Title' ].
		self tag: #td with: [ 
			self tag: #span attributes: { #class -> 'cn' } asDictionary with: [ stream << topic title ] ] ].
	self tag: #tr with: [ 
		self tag: #td with: [ stream << 'Email' ].
		self tag: #td with: [ self generateEmailFor: topic ] ]. 
	self tag: #tr with: [ 
		self tag: #td with: [ stream << 'Supervisors ' ].
		self tag: #td with: [ stream << topic supervisors ] ].
	self tag: #tr with: [ 
		self tag: #td with: [ stream << 'Keywords' ].
		self tag: #td  with: [ stream  << topic keywords ] ].
	self tag: #tr with: [ 
		self tag: #td with: [ stream << 'Context' ].
		self tag: #td with: [ stream << topic context ] ].
	topic goal 
		ifNotNil: [self tag: #tr with: [ 
		self tag: #td with: [ stream << 'Goal' ].
		self tag: #td with: [ stream << topic goal ] ] ].
	self tag: #tr with: [ 
		self tag: #td with: [ stream << 'Level' ].
		self tag: #td with: [ stream << topic level ] ].
	self tag: #tr with: [ 
		self tag: #td with: [ stream << 'Candidate' ].
		self tag: #td with: [ stream << topic candidate ] ]! !

!PharoTopicsPageTool methodsFor: 'html generation' stamp: 'StephaneDucasse 10/23/2013 14:49'!
generateEntryFor: topic
	self tag: #a attributes: { #name -> topic id } asDictionary with: [   
		self tag: #p with: [ 
			self tag: #table with: [ 
				stream << self tableColGroup.
				self generateEntryElementsFor: topic ] ] ]! !

!PharoTopicsPageTool methodsFor: 'constants' stamp: 'StephaneDucasse 2/11/2015 17:19'!
preamble
	^ '<p>Bored to do a project that nobody will ever look at it? </p>
	
	<p>Do a project in contact with a challenging and fun community of developers. 
	We collected some of the topics that interest the  <a href="http://www.pharo.org">Pharo</a> community. If you are interested to get an impact and feedback and more important have fun with us, take a topic contact the author and get started. Ideally we would love that part of what you are doing gets into Pharo or one of its packages. You can also participate to the next coming book.</p>
	
	<p>If you have other ideas of topics or if you are a teacher/researcher and you want to supervise one of the topics with us or alone, do not hesitate to contact us. We will update the list so that other people can know that you are working on this topic.</p>
	
<p>Pay attention Pharo is fun and it can change your life :) </p>
<a href="http://www.pharo.org"><img src="http://www.pharo-project.org/images/pharo.png"/></a>
<p class="footer">( In random order )</p>'! !

!PharoTopicsPageTool methodsFor: 'constants' stamp: 'StephaneDucasse 10/23/2013 14:54'!
tableColGroup
	^ '<colgroup><col style="text-align:left;width:25%;"/><col style="text-align:left;"/></colgroup>'! !

!PharoTopicsPageTool methodsFor: 'constants' stamp: 'StephaneDucasse 2/11/2015 17:20'!
title
	^ 'Pharo GSOC Topics'! !

Object subclass: #PharoPeopleREADME
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoPeople'!

!PharoPeopleREADME commentStamp: '<historical>' prior: 0!
Apparently it is using STON
	- need to do a configuration.
	
	- should add the possibility to fecth the data from a git repoPath 
	
	

ZnClient new 
 get: 'https://raw.github.com/pharo-project/pharo-project-proposals/master/Topics.st'.!
